Ruby - Bug #16603

Passing number or symbol to kwargs splat causes segmentation fualt
02/03/2020 07:53 AM - tompng (tomoya ishida)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.7.0p0 (2019-12-25 revision Backport: 2.5: DONTNEED, 2.6: DONTNEED, 2.7:
647ee6f091) [x86_64-darwin19], ruby DONE
2.8.0dev (2020-02-03T04:07:34Z master
0ab7f2f222) [x86_64-darwin19]

Description
Passing 1 or :a as a kwargs splat to a c-lang defined method causes segmentation fault. (It was a TypeError in ruby 2.6.0)

p **1
p **:a
rand **1

Passing it to an user-defined method won't cause segv, but it was a TypeError in ruby 2.6.0

def p2*;end
p2 **1 # nil (TypeError in ruby 2.6.0)
p2 **:a # nil (TypeError in ruby 2.6.0)

# these are ok

a=l; p **a # TypeError
a=:a; p **a # TypeError
def p2*;end

a=l; p2 **a # TypeError
a=:a; p2 **a # TypeError

Related issues:
Has duplicate Ruby - Bug #17141: Crash when parsing malformed input Closed

Associated revisions

Revision 11963da9%e8e98821860fbb0c0f2adc118860c814 - 02/03/2020 08:54 AM - hanachin (Seiei Miyagi)
Check type of empty keyword [Bug #16603]

Co-authored-by: Yusuke Endoh mame@ruby-lang.org

Revision 11963da9%e8e98821860fbb0c0f2adc118860c814 - 02/03/2020 08:54 AM - hanachin (Seiei Miyagi)
Check type of empty keyword [Bug #16603]

Co-authored-by: Yusuke Endoh mame@ruby-lang.org

Revision 11963da9 - 02/03/2020 08:54 AM - hanachin (Seiei Miyagi)
Check type of empty keyword [Bug #16603]

Co-authored-by: Yusuke Endoh mame@ruby-lang.org

Revision e778de2c82478dda930cfc8d795ed4e0e60ea775 - 09/06/2020 01:54 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 11963da9e8e98821860fbb0c0f2adc118860c814: [Backport #16603] [Backport #17141]

Check type of empty keyword [Bug #16603]

Co-authored-by: Yusuke Endoh <mame@ruby-lang.org>

Revision e778de2c82478dda930cfc8d795ed4e0e60ea775 - 09/06/2020 01:54 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 11963da9e8e98821860fbb0c0f2adc118860c814: [Backport #16603] [Backport #17141]
Check type of empty keyword [Bug #16603]

Co-authored-by: Yusuke Endoh <mame@ruby-lang.org>

Revision e778de2c - 09/06/2020 01:54 AM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 11963da9e8e98821860fbb0c0f2adc118860c814: [Backport #16603] [Backport #17141]

Check type of empty keyword [Bug #16603]

Co-authored-by: Yusuke Endoh <mame@ruby-lang.org>

History

#1 - 02/03/2020 08:48 AM - hanachin (Seiei Miyagi)

| created a patch for this bug.
https://github.com/ruby/ruby/pull/2874

#2 - 02/03/2020 08:55 AM - hanachin (Seiei Miyagi)
- Status changed from Open to Closed

Applied in changeset git|11963da9e8e98821860fbb0c0f2adc118860c814.

Check type of empty keyword [Bug #16603]

Co-authored-by: Yusuke Endoh mame@ruby-lang.org

#3 - 09/06/2020 01:43 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.5: UNKNOWN, 2.6: UNKNOWN, 2.7: UNKNOWN to 2.5: DONTNEED, 2.6: DONTNEED, 2.7: REQUIRED

#4 - 09/06/2020 01:43 AM - nagachika (Tomoyuki Chikanaga)
- Has duplicate Bug #17141: Crash when parsing malformed input added

#5 - 09/06/2020 01:55 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.5: DONTNEED, 2.6: DONTNEED, 2.7: REQUIRED to 2.5: DONTNEED, 2.6: DONTNEED, 2.7: DONE

ruby_2_7 e778de2c82478dda930cfc8d795ed4e0e60ea775 merged revision(s) 11963da9e8e98821860fbb0cOf2adc118860c814.

06/20/2025

22


https://github.com/ruby/ruby/pull/2874
https://bugs.ruby-lang.org/projects/ruby-master/repository/git/revisions/11963da9e8e98821860fbb0c0f2adc118860c814
https://bugs.ruby-lang.org/issues/16603
mailto:mame@ruby-lang.org
http://www.tcpdf.org

